module.exports = {
	splashButton: function(event, $el) {
        this.amount = 5;
        this.radius_to_expand = 50; // 20 pixels
        this.size_of_particile = 25;
        // this.colors = ['2980b9', '2c3e50', '8e44ad', '27ae60', '16a085', 'c0392b', 'f39c12', 'd35400'];
        this.colors = ['FF1461', '18FF92', '5A87FF', 'FBF38C'];
        this.timer = false;

        if($el) 
        {
            event = $el;
            event.target = event;
        }

        return this.run(event.target, event, $el);
    },
  
    generate: function() {
        $('.sp-particle').each(function(){
            if($(this).width() <= 0) $(this).remove();
        });

        var particles = [];

        for (i = 0; i < this.amount; i++) {
            var da = {
            	direction: Math.floor((Math.random() * 360) + 1), // 1- 360
            }

            particles.push(da);
        }

        return particles;
    },
  
    arrange: function(elm_cont, particles)
    {
        var _this = this;

        $.each(particles, function(key, value) {
            var color = _this.colors[Math.floor(Math.random()*_this.colors.length)];
            var styles = 'width:' + _this.size_of_particile + 'px;height:' + _this.size_of_particile + 'px;background-color:#' + color;
           
        	elm_cont.append('<div class="sp-particle" style="' + styles + '" data-direction="' + value.direction + '"></div>');
        });

        return elm_cont;
    },
  
    run: function(element, e, force) {
        $element = $(element);
        $e = $(element);

        if(!$element.hasClass('fa'))
        {
            $e = $element.find('.fa');
        }

        $e.removeClass('grow');

        setTimeout(function(){
            $e.addClass('grow');
        }, 100);

        // Remove grow after 500 ms
        setTimeout(function(){
            $e.removeClass('grow');
        }, 500);

        return; // Cancel the rest since doing just grow heart

        if(force)
        {
            $e.pageX = e.offset().left + (e.width());
            $e.pageY = e.offset().top + (e.height());
        }

        // Ignore this
        var parentOffset = $element.offset(); 
        var relX = e.pageX - parentOffset.left - (this.size_of_particile / 2);
        var relY = e.pageY - parentOffset.top - (this.size_of_particile / 2);

        // For element positioning
        relX = 5;
        relY = 5;

        var particles = this.generate();

        $('.particules-container').remove(); // remove older partlces

        var elm_cont = $('<div class="particules-container" style="position:absolute;left:' + relX + 'px;top:' + relY + 'px;z-index:3"></div>');
        elm_cont = this.arrange(elm_cont, particles);

        $e.append(elm_cont); 
        this.animate();
    },
  
    animate: function() {
        var _this = this;

        clearTimeout(this.timer);

    	$('.sp-particle').each(function(){
    	    _this.animateAction($(this));
        });
    },
  
    animateAction: function($elem) {
        var direction = $elem.attr('data-direction');
        var left = Math.cos(direction);
        var top = Math.sin(direction);

        var radius = Math.floor((Math.random() * this.radius_to_expand) + 10),

        left = left * radius;
        top = top * radius;

        this.timer = setTimeout(function(){
        	//$elem.css({left: left, top: top, width: 0, height: 0});
            $elem.css({
                'transform': 'translate(' + left + 'px, ' + top + 'px)', 
                width: 0, 
                height: 0
            });
        }, 1);
    }
};